#!/usr/bin/python
import gevent
from gevent import monkey
monkey.patch_all()
import urllib2
import gtk
import gobject
import time
    
def print_head(url):
    print 'Starting %s' % url
    data = urllib2.urlopen(url).read()
    print '%s: %s bytes: %r' % (url, len(data), data[:50])

def join_jobs(jobs):
    for job in jobs[:]:
        try:
            job.join(timeout=0.0)
        except KeyboardInterrupt:
            print "keyboard interrupt"
            gtk.main_quit()            
        if job.ready():
          jobs.remove(job)
    #if not jobs:
    #    gtk.main_quit()
    return bool(jobs) 

urls = ['http://www.google.com', 'http://www.yandex.ru', 'http://www.python.org']
jobs = [gevent.spawn(print_head, url) for url in urls]
# or would be better a gobject.timeout_add() ?
gobject.idle_add(join_jobs, jobs)

def timer(): 
    print "timer", time.time()
    return True    
gobject.timeout_add(100, timer)

gtk.main()
